/* 
    gVideo for v4l frame grabber driver and linux_dvb

    Copyright (C) 1999 Marcus Metzler (mocm@metzlerbros.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <gtk/gtk.h>
#ifdef PTHREADS
#include <glib.h>
#include <pthread.h>
#endif
#include "graphs.hh"

int main(int argc, char *argv[])
{
	int c, bpp = 0, remote = 0, norm = 0, onoff = 1, channel = 0;
	char *device = "/dev/video";

	for (;;) {
		if (-1 == (c = getopt(argc, argv, "rod:b:n:c:")))
			break;
		switch (c) {
		case 'r':
			remote = 1;
			break;
		case 'o':
			onoff = 0;
			break;
		case 'd':
			device = optarg;
			break;
		case 'b':
			bpp = atoi(optarg);
			break;
		case 'n':
			norm = atoi(optarg);
			break;
		case 'c':
			channel = atoi(optarg);
			break;

		case 'h':
		default:
			cerr << "usage: " << argv[0] << "  [ options ] " <<
			    endl << endl << "options:" << endl <<
			    "    -r        use on remote host" << endl <<
			    "    -o        start with capture off" << endl
			    << "    -d <dev>  video device    [" << device
			    << "]" << endl <<
			    "    -b <n>    displays color depth is <n> bpp"
			    << endl <<
			    "    -n <n>    set television norm (PAL=0,NTSC=1,SECAM=2)"
			    << endl << "    -c <n>    set channel" << endl;
			exit(1);
		}
	}

#ifdef PTHREADS
	g_thread_init(NULL);
#endif
	gtk_init(&argc, &argv);
	init_graphics(device, bpp, norm, remote, onoff, channel);

	return 0;
}
