/* 
   audio.cc for v4l devices

    Copyright (C) 2000 Marcus Metzler (mocm@metzlerbros.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "audio.hh"
#include "common.hh"
#include "interface.hh"

#include <DVB.hh>


static GtkWidget *audiomenu;
extern GtkAccelGroup *accel_group;
extern DVB dvb;

void set_audio(GtkWidget * w, gpointer data)
{
	int apid = (int)data;
        dvb.set_apid(apid);  
}

void CreateAudioMenu(GtkWidget * menu, char *szName)
{
	audiomenu = gtk_menu_item_new_with_label(szName);

	gtk_menu_bar_append(GTK_MENU_BAR(menu), audiomenu);
	gtk_widget_show(audiomenu);
	gtk_widget_set_sensitive(audiomenu, FALSE);

}



void set_audio_menu(Channel * chan)
{
	GtkWidget *menuitem;
	GtkWidget *menu;

	gtk_menu_item_remove_submenu(GTK_MENU_ITEM(audiomenu));
	menu = gtk_menu_new();
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(audiomenu), menu);


	if (chan && chan->apidnum > 1) {
		gtk_widget_set_sensitive(audiomenu, TRUE);

		for (int i = 0; i < chan->apidnum; i++) {
			char name[10];
			ostrstream str(name, 10);

			str << _("Audio ") << i << ends;
			menuitem = CreateMenuItem(menu, name, "", name,
						  GTK_SIGNAL_FUNC
						  (set_audio), 
						  (void *) chan->apids[i],
						  accel_group);
		}
	} else {
		gtk_widget_set_sensitive(audiomenu, FALSE);
	}
}


