/*	Definition der Speicherbereiche und Register des 
	DPRAM (von PC aus gesehen) und des DRAM (am AV7110)
*/

#define	DPRAM_BASE	0x4000
#define DPRAM_SIZE	0x2000
#define BOOT_STATE	(DPRAM_BASE + 0x3F8)
#define BOOT_SIZE	(DPRAM_BASE + 0x3FA)
#define BOOT_BASE	(DPRAM_BASE + 0x3FC)
//#define BOOT_BLOCK	(DPRAM_BASE + 0x800)
//#define BOOT_MAX_SIZE	0x800

#define BOOT_BLOCK	(DPRAM_BASE + 0x400)
#define BOOT_MAX_SIZE	0xc00


#define IRQ_STATE		(DPRAM_BASE + 0x0F4)
#define IRQ_STATE_EXT	(DPRAM_BASE + 0x0F6)
#define MSGSTATE		(DPRAM_BASE + 0x0F8)
#define FILT_STATE	(DPRAM_BASE + 0x0FA)
#define COMMAND		(DPRAM_BASE + 0x0FC)
#define COM_BUFF		(DPRAM_BASE + 0x100)
#define COM_BUFF_SIZE	0x20

#define BUFF1_BASE	(DPRAM_BASE + 0x120)
#define BUFF1_SIZE	0xE0

#define DATA_BUFF_BASE	(DPRAM_BASE + 0x200)
#define DATA_BUFF_SIZE	0x1C00

#define Reserved	(DPRAM_BASE + 0x1E00)
#define Reserved_SIZE	0x1D0

#define DEBUG_WINDOW	(DPRAM_BASE + 0x1FD0)
#define DEBUG_WIN_SIZE	0x28
#define	DBG_LOOP_CNT	(DEBUG_WINDOW + 0)
#define DBG_SEC_CNT		(DEBUG_WINDOW + 2)
#define DBG_AVRP_BUFF	(DEBUG_WINDOW + 4)
#define DBG_AVRP_PEAK	(DEBUG_WINDOW + 6)
#define DBG_MSG_CNT		(DEBUG_WINDOW + 8)
#define DBG_CODE_REG	(DEBUG_WINDOW + 10)
#define DBG_TTX_Q		(DEBUG_WINDOW + 12)
#define DBG_AUD_EN		(DEBUG_WINDOW + 14)
#define DBG_WRONG_COM	(DEBUG_WINDOW + 16)
#define DBG_ARR_OVFL	(DEBUG_WINDOW + 18)
#define DBG_BUFF_OVFL	(DEBUG_WINDOW + 20)
#define DBG_OVFL_CNT	(DEBUG_WINDOW + 22)
#define DBG_SEC_OVFL	(DEBUG_WINDOW + 24)

#define HANDSHAKE_REG	(DPRAM_BASE + 0x1FF8)
#define COM_IF_LOCK	(DPRAM_BASE + 0x1FFA)

#define IRQ_RX		(DPRAM_BASE + 0x1FFC)
#define IRQ_TX		(DPRAM_BASE + 0x1FFE)

#define DRAM_START_CODE		0x2e000404
#define DRAM_MAX_CODE_SIZE	0x00100000

#define RESET_LINE			2
#define DEBI_DONE_LINE		1
#define ARM_IRQ_LINE		0

#define DAC_CS	0x8000
#define DAC_CDS	0x0000
